module("luci.controller.advanced_reboot",package.seeall)
local e=require"luci.util"
local n=require"nixio.fs"
local t=require"luci.sys"
local t=require"luci.http"
local t=require"luci.dispatcher"
local a=require"luci.i18n"
local s=require"luci.template"
local c=require"luci.ip"
local d=require"luci.http"
local u=require"luci.sys"
local v=require"luci.dispatcher"
local b=require"luci.model.uci".cursor()
local t="advanced-reboot"
local y="/usr/lib/lua/luci/"..t.."/devices/"
function logger(a)
e.exec("logger -t "..t.." '"..tostring(a).."'")
end
function is_alt_mountable(t,e)
if t:sub(1,3)=="mtd"and
e:sub(1,3)=="mtd"and
n.access("/usr/sbin/ubiattach")and
n.access("/usr/sbin/ubiblock")and
n.access("/bin/mount")then
return true
else
return false
end
end
function get_partition_os_info(t)
local o,i
if n.access("/etc/os-release")then
o=e.trim(e.exec('. /etc/os-release && echo "$PRETTY_NAME"'))
if o:find("SNAPSHOT")then
o=e.trim(e.exec('. /etc/os-release && echo "$OPENWRT_RELEASE"'))
end
end
logger(a.translate("attempting to mount alternative partition").." (mtd"..tostring(t)..")")
alt_partition_unmount(t)
alt_partition_mount(t)
if n.access("/alt/rom/etc/os-release")then
i=e.trim(e.exec('. /alt/rom/etc/os-release && echo "$PRETTY_NAME"'))
if i:find("SNAPSHOT")then
i=e.trim(e.exec('. /alt/rom/etc/os-release && echo "$OPENWRT_RELEASE"'))
end
end
logger(a.translate("attempting to unmount alternative partition").." (mtd"..tostring(t)..")")
alt_partition_unmount(t)
return o,i
end
function alt_partition_mount(a)
local t
e.exec('for i in rom overlay firmware; do [ ! -d "$i" ] && mkdir -p "/alt/${i}"; done')
t=tostring(e.exec("ubiattach -m "..tostring(a)))
_,_,t=t:find("UBI device number (%d+)")
if not t then
e.exec("ubidetach -m "..tostring(a))
return
end
e.exec("ubiblock --create /dev/ubi"..t.."_0")
e.exec("mount -t squashfs -o ro /dev/ubiblock"..t.."_0 /alt/rom")
e.exec("mount -t ubifs /dev/ubi"..t.."_1 /alt/overlay")
end
function alt_partition_unmount(a)
local t
local t=tonumber(e.exec("ubinfo | grep 'Present UBI devices' | grep -c ','"))
t=t and t+1 or 10
e.exec("[ -d /alt/overlay ] && umount /alt/overlay")
e.exec("[ -d /alt/rom ] && umount /alt/rom")
for t=0,t do
if not n.access("/sys/devices/virtual/ubi/ubi"..tostring(t).."/mtd_num")then break end
ubi_mtd=tonumber(e.trim(e.exec("cat /sys/devices/virtual/ubi/ubi"..t.."/mtd_num")))
if ubi_mtd and ubi_mtd==a then
e.exec("ubiblock --remove /dev/ubi"..tostring(t).."_0")
e.exec("ubidetach -m "..tostring(a))
e.exec('rm -rf /alt')
end
end
end
function obtain_device_info()
local t,f,w,s,c,h,u,i,o
local p,r
local m,d,d,l
local d=e.trim(e.exec("cat /tmp/sysinfo/board_name"))
for v in n.dir(y)do
local y=loadfile(y..v)
setfenv(y,{_=a.translate})
t=y()
f=t.boardName:gsub('%p','')
if d and d:gsub('%p',''):match(f)then
if t.labelOffset then
if t.partition1MTD then
s=e.trim(e.exec("dd if=/dev/"..t.partition1MTD.." bs=1 skip="..t.labelOffset.." count=128".."  2>/dev/null"))
w,c=s:match('(Linux)-([%d|.]+)')
end
if t.partition2MTD then
h=e.trim(e.exec("dd if=/dev/"..t.partition2MTD.." bs=1 skip="..t.labelOffset.." count=128".."  2>/dev/null"))
w,u=h:match('(Linux)-([%d|.]+)')
end
if s and s:find("LEDE")then i="LEDE"end
if s and s:find("OpenWrt")then i="OpenWrt"end
if s and t.vendorName and s:find(t.vendorName)then i=t.vendorName end
if h and h:find("LEDE")then o="LEDE"end
if h and h:find("OpenWrt")then o="OpenWrt"end
if h and t.vendorName and h:find(t.vendorName)then o=t.vendorName end
if not i then i=t.vendorName.."/"..a.translate("Unknown")end
if not o then o=t.vendorName.."/"..a.translate("Unknown")end
if i and c then i=i.." (Linux "..c..")"end
if o and u then o=o.." (Linux "..u..")"end
else
i=t.vendorName.."/"..a.translate("Unknown").." ("..a.translate("Compressed")..")"
o=t.vendorName.."/"..a.translate("Unknown").." ("..a.translate("Compressed")..")"
end
if t.bootEnv1 then
if n.access("/usr/sbin/fw_printenv")and n.access("/usr/sbin/fw_setenv")then
r=tonumber(e.trim(e.exec("fw_printenv -n "..t.bootEnv1)))
end
else
if not l then l=e.trim(e.exec(". /lib/functions.sh; find_mtd_part 0:DUAL_FLAG"))end
if l then
r=tonumber(e.exec("dd if="..l.." bs=1 count=1 2>/dev/null | hexdump -n 1 -e '1/1 \"%d\"'"))
else
p=p or a.translate("Unable to find Dual Boot Flag Partition.")
e.perror(a.translate("Unable to find Dual Boot Flag Partition."))
end
end
if is_alt_mountable(t.partition1MTD,t.partition2MTD)then
if r==t.bootEnv1Partition1Value then
m=tonumber(t.partition2MTD:sub(4))+1
else
m=tonumber(t.partition1MTD:sub(4))+1
end
local a,e=get_partition_os_info(m)
if r==t.bootEnv1Partition1Value then
i=a or i
o=e or o
else
i=e or i
o=a or o
end
end
return d,t.vendorName.." "..t.deviceName,t.bootEnv1,t.bootEnv1Partition1Value,i,t.bootEnv1Partition2Value,o,t.bootEnv2,t.bootEnv2Partition1Value,t.bootEnv2Partition1Value,r
end
end
return d,nil,nil,nil,nil,nil,nil,nil,nil,nil,nil
end
function index()
entry({"admin","system","advanced_reboot"},call("action_template"),_("Advanced Reboot"),90)
entry({"admin","system","advanced_reboot","reboot"},post("action_reboot"))
entry({"admin","system","advanced_reboot","alternative_reboot"},post("action_altreboot"))
entry({"admin","system","advanced_reboot","power_off"},post("action_poweroff"))
end
function action_template()
local a,n,r,e,o,t,h,r,r,r,i=obtain_device_info()
s.render("advanced_reboot/advanced_reboot",{
romBoardName=a,
device_name=n,
bev1p1=e,
p1_os=o,
bev1p2=t,
p2_os=h,
current_partition=i,
errorMessage=errorMessage})
end
function action_reboot()
s.render("advanced_reboot/applyreboot",{
title=a.translate("Rebooting..."),
msg=a.translate("The system is rebooting now.<br /> DO NOT POWER OFF THE DEVICE!<br /> Wait a few minutes before you try to reconnect. It might be necessary to renew the address of your computer to reach the device again, depending on your settings."),
addr=c.new(type(c)=="string"and c or"192.168.1.1")or"192.168.1.1"
})
u.reboot()
end
function action_altreboot()
local z,j,o,f,g,y,k,t,p,q,x=obtain_device_info()
local r,m,w,h,l,i
errorMessage=nil
h=0
if d.formvalue("cancel")then
d.redirect(v.build_url('admin/system/advanced_reboot'))
return
end
local d=tonumber(d.formvalue("step")or 1)
if d==1 then
if n.access("/usr/sbin/fw_printenv")and n.access("/usr/sbin/fw_setenv")then
s.render("advanced_reboot/alternative_reboot",{})
else
s.render("advanced_reboot/advanced_reboot",{errorMessage=a.translate("No access to fw_printenv or fw_printenv!")})
end
elseif d==2 then
if o or t then
if o then
l=tonumber(e.trim(e.exec("fw_printenv -n "..o)))
if not l then
errorMessage=errorMessage..a.translate("Unable to obtain firmware environment variable")..": "..o..". "
e.perror(a.translate("Unable to obtain firmware environment variable")..": "..o..".")
else
i=l==f and y or f
h=u.call("fw_setenv "..o.." "..i)
if h~=0 then
errorMessage=errorMessage or""..a.translate("Unable to set firmware environment variable")..": "..o.." "..a.translate("to").." "..i..". "
e.perror(a.translate("Unable to set firmware environment variable")..": "..o.." "..a.translate("to").." "..i..".")
end
end
end
if t then
l=e.trim(e.exec("fw_printenv -n "..t))
if not l then
errorMessage=errorMessage or""..a.translate("Unable to obtain firmware environment variable")..": "..t..". "
e.perror(a.translate("Unable to obtain firmware environment variable")..": "..t..".")
else
i=l==p and q or p
h=u.call("fw_setenv "..t.." '"..i.."'")
if h~=0 then
errorMessage=errorMessage or""..a.translate("Unable to set firmware environment variable")..": "..t.." "..a.translate("to").." "..i..". "
e.perror(a.translate("Unable to set firmware environment variable")..": "..t.." "..a.translate("to").." "..i..".")
end
end
end
else
if not r then r=e.trim(e.exec(". /lib/functions.sh; find_mtd_part 0:DUAL_FLAG"))end
if not r then
errorMessage=errorMessage..a.translate("Unable to find Dual Boot Flag Partition.".." ")
e.perror(a.translate("Unable to find Dual Boot Flag Partition."))
else
m=tonumber(e.exec("dd if="..r.." bs=1 count=1 2>/dev/null | hexdump -n 1 -e '1/1 \"%d\"'"))
w=m and m==1 and"\\xff"or"\\x01"
if w then
h=u.call("printf \""..w.."\" >"..r)
if h~=0 then
errorMessage=errorMessage or""..a.translate("Unable to set Dual Boot Flag Partition entry for partition")..": "..r..". "
e.perror(a.translate("Unable to set Dual Boot Flag Partition entry for partition")..": "..r..".")
end
end
end
end
if not errorMessage then
s.render("advanced_reboot/applyreboot",{
title=a.translate("Rebooting..."),
msg=a.translate("The system is rebooting to an alternative partition now.<br /> DO NOT POWER OFF THE DEVICE!<br /> Wait a few minutes before you try to reconnect. It might be necessary to renew the address of your computer to reach the device again, depending on your settings."),
addr=c.new(b:get("network","lan","ipaddr"))or"192.168.1.1"
})
u.reboot()
else
s.render("advanced_reboot/advanced_reboot",{
romBoardName=z,
device_name=j,
bev1p1=f,
p1_os=g,
bev1p2=y,
p2_os=k,
current_partition=x,
errorMessage=errorMessage})
end
end
end
function action_poweroff()
if d.formvalue("cancel")then
d.redirect(v.build_url('admin/system/advanced_reboot'))
return
end
local e=tonumber(d.formvalue("step")or 1)
if e==1 then
if n.access("/sbin/poweroff")then
s.render("advanced_reboot/power_off",{})
else
s.render("advanced_reboot/advanced_reboot",{})
end
elseif e==2 then
s.render("advanced_reboot/applyreboot",{
title=a.translate("Shutting down..."),
msg=a.translate("The system is shutting down now.<br /> DO NOT POWER OFF THE DEVICE!<br /> It might be necessary to renew the address of your computer to reach the device again, depending on your settings."),
addr=c.new(b:get("network","lan","ipaddr"))or"192.168.1.1"
})
u.call("/sbin/poweroff")
end
end
